﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.Diagnostics;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Windows.Forms;
using CefSharp;
using CefSharp.WinForms;
using SixIpc.SplashScreen;

namespace JC.DeviceMonitor.SingleCrystal.Client
{
    //[ComVisible(true)]
    public class JsManager
    {
        private ChromiumWebBrowser webBrowser;

        private MainForm mainForm;


        public void Browser_FrameLoadEnd(object sender, FrameLoadEndEventArgs e)
        {
            string deviceCode = System.Configuration.ConfigurationManager.AppSettings["deviceCode"];
            //设置设备编号
            webBrowser.GetBrowser().MainFrame.ExecuteJavaScriptAsync("setDeviceCode('" + deviceCode + "')");

            Splasher.Status = "同步数据完成,启动成功......";
            Splasher.Close();

            this.mainForm.WindowState = FormWindowState.Maximized;


        }
        public void Browser_LoadingStateChanged(object sender, LoadingStateChangedEventArgs e)
        {
            Splasher.Status = "正在同步MES数据............";
        }

        public JsManager(MainForm form, ChromiumWebBrowser webBrowser)
        {
            this.mainForm = form;
            this.webBrowser = webBrowser;
        }

        public void showDevTools()
        {
            webBrowser.ShowDevTools();
        }

        /// <summary>
        /// 最小化
        /// </summary>
        public void minimize()
        {
            mainForm.minimize();
        }

        public void opencmd()
        {
            ProcessStartInfo start = new ProcessStartInfo("cmd.exe", "/c pause");
            Process.Start(start);
        }

        public string test(string message)
        {
            System.Windows.Forms.MessageBox.Show(message);
            return "收到";
        }

        public void sendToJs(string a)
        {
            webBrowser.GetBrowser().MainFrame.ExecuteJavaScriptAsync("testJs('aaa')");
        }

        /// <summary>
        /// 获取系统版本号
        /// </summary>
        /// <returns></returns>
        public string getProjectVersion()
        {
            string version = ConfigurationManager.AppSettings["version"];
            return version;
        }

        /// <summary>
        /// 获取设备机台号
        /// </summary>
        /// <returns></returns>
        public string getDeviceCode()
        {
            string deviceCode = ConfigurationManager.AppSettings["deviceCode"];
            return deviceCode;
        }


    }
}
