﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using CefSharp;
using CefSharp.WinForms;
using SixIpc;
using SixIpc.SplashScreen;

namespace JC.DeviceMonitor.SingleCrystal.Client
{
    public partial class MainForm : Form
    {

        public MainForm()
        {
            InitializeComponent();
            InitBrowser();

        }
        public ChromiumWebBrowser browser;
        public JsManager jsManager;
        public void InitBrowser()
        {
        }


        private void MainForm_Load(object sender, EventArgs e)
        {
            
            Splasher.Status = "工控机程序正在启动......";

            var settings = getCefSettings();
            Cef.Initialize(settings,false,false);
            string contentUrl = System.Configuration.ConfigurationManager.AppSettings["contentUrl"];
            browser = new ChromiumWebBrowser(contentUrl);
            Font font = new Font("微软雅黑", 10.5f);
            browser.Font = font;
            browser.Dock = DockStyle.Fill;
            this.Controls.Add(browser);
            //F12调试工具  F5强制刷新
            browser.KeyboardHandler = new CEFKeyBoardHander();

            Splasher.Status = "正在同步MES数据......";

            //this.Visible = false;


            jsManager = new JsManager(this, browser);
            browser.RegisterJsObject("jsManager", jsManager, false);
            //加载完成的事件
            browser.FrameLoadEnd += jsManager.Browser_FrameLoadEnd;
            browser.LoadingStateChanged += jsManager.Browser_LoadingStateChanged;

            Control.CheckForIllegalCrossThreadCalls = false;
        }



        CefSettings getCefSettings()
        {
            var setting = new CefSettings();
            setting.CefCommandLineArgs.Add("disable-gpu", "1");
            setting.Locale = "zh-CN";
            setting.AcceptLanguageList = "zh-CN";
            setting.MultiThreadedMessageLoop = true;
            setting.CachePath = Directory.GetCurrentDirectory() + @"\CHBrowser\BrowserCache";//缓存路径
            setting.AcceptLanguageList = "zh-CN,zh;q=0.8";//浏览器引擎的语言
            //setting.LocalesDirPath = "CHBrowser/localeDir";//日志
            setting.LogFile = Directory.GetCurrentDirectory() + @"\CHBrowser\LogData";//日志文件
            setting.PersistSessionCookies = true;//

            return setting;
        }


        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            try
            {
                browser.CloseDevTools();
                browser.GetBrowser().CloseBrowser(true);

                browser.Dispose();
                //browser.Dispose();
                //CefSharp.Cef.Shutdown();

                Console.WriteLine("ddd");
            }
            catch { }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            jsManager.sendToJs("are you ok");
        }

        private void button2_Click(object sender, EventArgs e)
        {
            jsManager.showDevTools();
        }

        public void minimize()
        {
            if (InvokeRequired)
            {
                this.Invoke(new Action(() => { this.WindowState = FormWindowState.Minimized; }));
            }
            else
            {
                WindowState = FormWindowState.Minimized;
            }
        }

        
    }
}
